import { TerminalStage } from '../../stages';
class FindFirstCollector extends TerminalStage {
    _firstElement;
    consume(element) {
        if (this._firstElement === undefined) {
            this._firstElement = element;
            this.broadcast("TERMINATE_EARLY" /* PipelineEvent.TERMINATE_EARLY */);
        }
    }
    get() {
        return this._firstElement;
    }
}
/**
 * Return a short-circuiting terminal stage that retrieves the very first element encountered in the pipeline.
 * The pipeline will terminate as soon as an element is found due to its short-circuiting nature, otherwise,
 * `undefined` is returned.
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 */
export function findFirst() {
    return new FindFirstCollector();
}
//# sourceMappingURL=findFirst.js.map