import { TerminalStage } from '../../stages';
class GroupByCollector extends TerminalStage {
    _keyExtractor;
    _valueMapper;
    _groupMap = new Map();
    constructor(_keyExtractor, _valueMapper) {
        super();
        this._keyExtractor = _keyExtractor;
        this._valueMapper = _valueMapper;
    }
    consume(element) {
        const key = this._keyExtractor(element);
        if (!this._groupMap.has(key)) {
            this._groupMap.set(key, []);
        }
        this._groupMap.get(key).push(this._valueMapper?.(element) || element);
    }
    get() {
        return this._groupMap;
    }
}
export function groupBy(keyExtractor, valueMapper) {
    return new GroupByCollector(keyExtractor, valueMapper);
}
//# sourceMappingURL=groupBy.js.map