import { TerminalStage } from '../../stages';
class ArrayCollector extends TerminalStage {
    _elements = [];
    consume(element) {
        this._elements.push(element);
    }
    get() {
        return this._elements;
    }
}
/**
 * Return a terminal stage that collects all elements in the pipeline into an array.
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 */
export function toArray() {
    return new ArrayCollector();
}
//# sourceMappingURL=toArray.js.map