import { TerminalStage } from '../../stages';
class ToMapCollector extends TerminalStage {
    _keyExtractor;
    _valueMapper;
    _map = new Map();
    constructor(_keyExtractor, _valueMapper) {
        super();
        this._keyExtractor = _keyExtractor;
        this._valueMapper = _valueMapper;
    }
    consume(element) {
        this._map.set(this._keyExtractor(element), this._valueMapper?.(element) || element);
    }
    get() {
        return this._map;
    }
}
export function toMap(keyExtractor, valueMapper) {
    return new ToMapCollector(keyExtractor, valueMapper);
}
//# sourceMappingURL=toMap.js.map