import { TerminalStage } from '../../stages';
class ToObjectCollector extends TerminalStage {
    _keyExtractor;
    _valueMapper;
    _object = {};
    constructor(_keyExtractor, _valueMapper) {
        super();
        this._keyExtractor = _keyExtractor;
        this._valueMapper = _valueMapper;
    }
    consume(element) {
        this._object[this._extractKey(element)] = this._valueMapper?.(element) || element;
    }
    _extractKey(element) {
        const key = this._keyExtractor(element);
        if (typeof key !== 'string' && typeof key !== 'number') {
            throw new Error(`[toObject() collector] Extracted key is not string or number, the element received was ${JSON.stringify(element)}`);
        }
        return key;
    }
    get() {
        return this._object;
    }
}
export function toObject(keyExtractor, valueMapper) {
    return new ToObjectCollector(keyExtractor, valueMapper);
}
//# sourceMappingURL=toObject.js.map