import { IntermediateStage } from '../../stages';
class MapStage extends IntermediateStage {
    _mapper;
    constructor(_mapper) {
        super();
        this._mapper = _mapper;
    }
    consume(element, hasMoreDataUpstream) {
        this._downstream.consume(this._mapper(element), hasMoreDataUpstream);
    }
}
/**
 * Return an intermediate stage that transforms each element according the provided mapping function.
 *
 * @param mapper
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 * @template OUT The type parameter of each outgoing element to be forwarded to the downstream stage.
 *
 * @returns
 */
export function map(mapper) {
    return new MapStage(mapper);
}
//# sourceMappingURL=map.js.map