import { IntermediateStage } from '../../stages';
class PeekStage extends IntermediateStage {
    _action;
    constructor(_action) {
        super();
        this._action = _action;
    }
    consume(element, hasMoreDataUpstream) {
        this._action(element);
        this._downstream.consume(element, hasMoreDataUpstream);
    }
}
/**
 * Return an intermediate stage that performs an action on each element.
 *
 * @param action The action to perform on each element.
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 */
export function peek(action) {
    return new PeekStage(action);
}
//# sourceMappingURL=peek.js.map